Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/TreeLayout.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/TreeLayout.cs	(revision 9835)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/TreeLayout.cs	(revision 9835)
@@ -0,0 +1,287 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views {
+  public class Node {
+    public Node Thread;
+    public Node Ancestor;
+
+    public float Mod; // position modifier
+    public float Prelim;
+    public float Change;
+    public float Shift;
+    public int Number;
+
+    public float X;
+    public float Y;
+
+    public ISymbolicExpressionTreeNode SymbolicExpressionTreeNode;
+
+    //    public int Number {
+    //      get {
+    //        var parent = SymbolicExpressionTreeNode.Parent;
+    //        if (parent == null) return -1;
+    //        return parent.IndexOfSubtree(SymbolicExpressionTreeNode);
+    //      }
+    //    }
+
+    public bool IsLeaf {
+      get { return SymbolicExpressionTreeNode.SubtreeCount == 0; }
+    }
+  }
+
+  public class TreeLayout {
+    private float distance = 5;
+    public float Distance {
+      get { return distance; }
+      set { distance = value; }
+    }
+
+    private ISymbolicExpressionTree symbolicExpressionTree;
+    public ISymbolicExpressionTree SymbolicExpressionTree {
+      get { return symbolicExpressionTree; }
+      set {
+        symbolicExpressionTree = value;
+        nodes.Clear();
+        var treeNodes = SymbolicExpressionTree.IterateNodesBreadth().ToList();
+        foreach (var treeNode in treeNodes) {
+          var node = new Node { SymbolicExpressionTreeNode = treeNode };
+          node.Ancestor = node;
+          nodes.Add(treeNode, node);
+        }
+        // assign a number to each node, representing its position among its siblings (parent.IndexOfSubtree)
+        foreach (var treeNode in treeNodes.Where(x => x.SubtreeCount > 0)) {
+          for (int i = 0; i != treeNode.SubtreeCount; ++i) {
+            nodes[treeNode.GetSubtree(i)].Number = i;
+          }
+        }
+        var r = nodes[symbolicExpressionTree.Root];
+        FirstWalk(r);
+        SecondWalk(r, -r.Prelim);
+        NormalizeCoordinates();
+      }
+    }
+
+    /// <summary>
+    /// Returns a map of coordinates for each node in the symbolic expression tree.
+    /// </summary>
+    /// <returns></returns>
+    public Dictionary<ISymbolicExpressionTreeNode, PointF> GetNodeCoordinates() {
+      var dict = new Dictionary<ISymbolicExpressionTreeNode, PointF>();
+      if (nodes == null || nodes.Count == 0) return dict;
+      foreach (var node in nodes.Values) {
+        dict.Add(node.SymbolicExpressionTreeNode, new PointF { X = node.X, Y = node.Y });
+      }
+      return dict;
+    }
+
+    /// <summary>
+    /// Returns the bounding box for this layout. When the layout is normalized, the rectangle should be [0,0,xmin,xmax].
+    /// </summary>
+    /// <returns></returns>
+    public RectangleF Bounds() {
+      float xmin, xmax, ymin, ymax; xmin = xmax = ymin = ymax = 0;
+      var list = nodes.Values.ToList();
+      for (int i = 0; i != list.Count; ++i) {
+        float x = list[i].X, y = list[i].Y;
+        if (xmin > x) xmin = x;
+        if (xmax < x) xmax = x;
+        if (ymin > y) ymin = y;
+        if (ymax < y) ymax = y;
+      }
+      return new RectangleF(xmin, ymin, xmax + distance, ymax + distance);
+    }
+
+    /// <summary>
+    /// Returns a string containing all the coordinates (useful for debugging).
+    /// </summary>
+    /// <returns></returns>
+    public string DumpCoordinates() {
+      if (nodes == null || nodes.Count == 0) return string.Empty;
+      return nodes.Values.Aggregate("", (current, node) => current + (node.X + " " + node.Y + Environment.NewLine));
+    }
+
+    private readonly Dictionary<ISymbolicExpressionTreeNode, Node> nodes;
+
+    public TreeLayout() {
+      nodes = new Dictionary<ISymbolicExpressionTreeNode, Node>();
+    }
+
+    /// <summary>
+    /// Transform node coordinates so that all coordinates are positive and start from 0.
+    /// </summary>
+    private void NormalizeCoordinates() {
+      var list = nodes.Values.ToList();
+      float xmin = 0, ymin = 0;
+      for (int i = 0; i != list.Count; ++i) {
+        if (xmin > list[i].X) xmin = list[i].X;
+        if (ymin > list[i].Y) ymin = list[i].Y;
+      }
+      for (int i = 0; i != list.Count; ++i) {
+        list[i].X -= xmin;
+        list[i].Y -= ymin;
+      }
+    }
+
+    private void FirstWalk(Node v) {
+      Node w;
+      if (v.IsLeaf) {
+        w = LeftSibling(v);
+        if (w != null) {
+          v.Prelim = w.Prelim + distance;
+        }
+      } else {
+        var symbExprNode = v.SymbolicExpressionTreeNode;
+        var defaultAncestor = nodes[symbExprNode.GetSubtree(0)]; // let defaultAncestor be the leftmost child of v
+        for (int i = 0; i != symbExprNode.SubtreeCount; ++i) {
+          var s = symbExprNode.GetSubtree(i);
+          w = nodes[s];
+          FirstWalk(w);
+          Apportion(w, ref defaultAncestor);
+        }
+        ExecuteShifts(v);
+        int c = symbExprNode.SubtreeCount;
+        var leftmost = nodes[symbExprNode.GetSubtree(0)];
+        var rightmost = nodes[symbExprNode.GetSubtree(c - 1)];
+        float midPoint = (leftmost.Prelim + rightmost.Prelim) / 2;
+        w = LeftSibling(v);
+        if (w != null) {
+          v.Prelim = w.Prelim + distance;
+          v.Mod = v.Prelim - midPoint;
+        } else {
+          v.Prelim = midPoint;
+        }
+      }
+    }
+
+    private void SecondWalk(Node v, float m) {
+      v.X = v.Prelim + m;
+      v.Y = symbolicExpressionTree.Root.GetBranchLevel(v.SymbolicExpressionTreeNode) * distance;
+      var symbExprNode = v.SymbolicExpressionTreeNode;
+      foreach (var s in symbExprNode.Subtrees) {
+        SecondWalk(nodes[s], m + v.Mod);
+      }
+    }
+
+    private void Apportion(Node v, ref Node defaultAncestor) {
+      var w = LeftSibling(v);
+      if (w == null) return;
+      Node vip = v;
+      Node vop = v;
+      Node vim = w;
+      Node vom = LeftmostSibling(vip);
+
+      float sip = vip.Mod;
+      float sop = vop.Mod;
+      float sim = vim.Mod;
+      float som = vom.Mod;
+
+      while (NextRight(vim) != null && NextLeft(vip) != null) {
+        vim = NextRight(vim);
+        vip = NextLeft(vip);
+        vom = NextLeft(vom);
+        vop = NextRight(vop);
+        vop.Ancestor = v;
+        float shift = (vim.Prelim + sim) - (vip.Prelim + sip) + distance;
+        if (shift > 0) {
+          var ancestor = Ancestor(vim, v) ?? defaultAncestor;
+          MoveSubtree(ancestor, v, shift);
+          sip += shift;
+          sop += shift;
+        }
+        sim += vim.Mod;
+        sip += vip.Mod;
+        som += vom.Mod;
+        sop += vop.Mod;
+      }
+      if (NextRight(vim) != null && NextRight(vop) == null) {
+        vop.Thread = NextRight(vim);
+        vop.Mod += (sim - sop);
+      }
+      if (NextLeft(vip) != null && NextLeft(vom) == null) {
+        vom.Thread = NextLeft(vip);
+        vom.Mod += (sip - som);
+        defaultAncestor = v;
+      }
+    }
+
+    private void MoveSubtree(Node wm, Node wp, float shift) {
+      int subtrees = wp.Number - wm.Number;
+      wp.Change -= shift / subtrees;
+      wp.Shift += shift;
+      wm.Change += shift / subtrees;
+      wp.Prelim += shift;
+      wp.Mod += shift;
+    }
+
+    private void ExecuteShifts(Node v) {
+      if (v.IsLeaf) return;
+      float shift = 0;
+      float change = 0;
+      for (int i = v.SymbolicExpressionTreeNode.SubtreeCount - 1; i >= 0; --i) {
+        var subtree = v.SymbolicExpressionTreeNode.GetSubtree(i);
+        var w = nodes[subtree];
+        w.Prelim += shift;
+        w.Mod += shift;
+        change += w.Change;
+        shift += (w.Shift + change);
+      }
+    }
+
+    #region Helper functions
+    private Node Ancestor(Node vi, Node v) {
+      var ancestor = vi.Ancestor;
+      return ancestor.SymbolicExpressionTreeNode.Parent == v.SymbolicExpressionTreeNode.Parent ? ancestor : null;
+    }
+
+    private Node NextLeft(Node v) {
+      int c = v.SymbolicExpressionTreeNode.SubtreeCount;
+      return c == 0 ? v.Thread : nodes[v.SymbolicExpressionTreeNode.GetSubtree(0)]; // return leftmost child
+    }
+
+    private Node NextRight(Node v) {
+      int c = v.SymbolicExpressionTreeNode.SubtreeCount;
+      return c == 0 ? v.Thread : nodes[v.SymbolicExpressionTreeNode.GetSubtree(c - 1)]; // return rightmost child
+    }
+
+    private Node LeftSibling(Node n) {
+      var parent = n.SymbolicExpressionTreeNode.Parent;
+      if (parent == null) return null;
+      int i = parent.IndexOfSubtree(n.SymbolicExpressionTreeNode);
+      if (i == 0) return null;
+      return nodes[parent.GetSubtree(i - 1)];
+    }
+
+    private Node LeftmostSibling(Node n) {
+      var parent = n.SymbolicExpressionTreeNode.Parent;
+      if (parent == null) return null;
+      int i = parent.IndexOfSubtree(n.SymbolicExpressionTreeNode);
+      if (i == 0) return null;
+      return nodes[parent.GetSubtree(0)];
+    }
+    #endregion
+  }
+}
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/VisualSymbolicExpressionTreeNode.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/VisualSymbolicExpressionTreeNode.cs	(revision 9835)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/VisualSymbolicExpressionTreeNode.cs	(revision 9835)
@@ -0,0 +1,129 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views {
+  public class VisualSymbolicExpressionTreeNode : object {
+    private static readonly Color defaultLineColor = Color.Black;
+    private static readonly Color defaultTextColor = Color.Black;
+    private static readonly Color defaultFillColor = Color.White;
+    private const int defaultPreferredWidth = 70;
+    private const int defaultPreferredHeight = 46;
+
+    public VisualSymbolicExpressionTreeNode(ISymbolicExpressionTreeNode symbolicExpressionTreeNode) :
+      this(symbolicExpressionTreeNode, defaultLineColor) {
+    }
+
+    public VisualSymbolicExpressionTreeNode(ISymbolicExpressionTreeNode symbolicExpressionTreeNode, Color lineColor) :
+      this(symbolicExpressionTreeNode, lineColor, defaultTextColor) {
+    }
+
+    public VisualSymbolicExpressionTreeNode(ISymbolicExpressionTreeNode symbolicExpressionTreeNode, Color lineColor, Color textColor) :
+      this(symbolicExpressionTreeNode, lineColor, textColor, defaultFillColor) {
+    }
+
+    public VisualSymbolicExpressionTreeNode(ISymbolicExpressionTreeNode symbolicExpressionTreeNode, Color lineColor, Color textColor, Color fillColor) :
+      this(symbolicExpressionTreeNode, lineColor, textColor, fillColor, defaultPreferredWidth, defaultPreferredHeight) {
+    }
+
+    public VisualSymbolicExpressionTreeNode(ISymbolicExpressionTreeNode symbolicExpressionTreeNode, Color lineColor, Color textColor, Color fillColor, int width, int height) {
+      this.symbolicExpressionTreeNode = symbolicExpressionTreeNode;
+      this.lineColor = lineColor;
+      this.textColor = textColor;
+      this.fillColor = fillColor;
+      this.preferredWidth = width;
+      this.preferredHeight = height;
+      this.ToolTip = symbolicExpressionTreeNode.ToString();
+    }
+
+    #region members for internal use only
+    private int x;
+    public int X {
+      get { return x; }
+      internal set { this.x = value; }
+    }
+
+    private int y;
+    public int Y {
+      get { return y; }
+      internal set { this.y = value; }
+    }
+
+    private int width;
+    public int Width {
+      get { return this.width; }
+      internal set { this.width = value; }
+    }
+
+    private int height;
+    public int Height {
+      get { return this.height; }
+      internal set { this.height = value; }
+    }
+    #endregion
+
+    private ISymbolicExpressionTreeNode symbolicExpressionTreeNode;
+    public ISymbolicExpressionTreeNode SymbolicExpressionTreeNode {
+      get { return this.symbolicExpressionTreeNode; }
+      set {
+        symbolicExpressionTreeNode = value;
+        ToolTip = SymbolicExpressionTreeNode.ToString();
+      }
+    }
+
+    private int preferredWidth;
+    public int PreferredWidth {
+      get { return this.preferredWidth; }
+      set { this.preferredWidth = value; }
+    }
+
+    private int preferredHeight;
+    public int PreferredHeight {
+      get { return this.preferredHeight; }
+      set { this.preferredHeight = value; }
+    }
+
+    private Color lineColor;
+    public Color LineColor {
+      get { return this.lineColor; }
+      set { this.lineColor = value; }
+    }
+
+    private Color textColor;
+    public Color TextColor {
+      get { return this.textColor; }
+      set { this.textColor = value; }
+    }
+
+    private Color fillColor;
+    public Color FillColor {
+      get { return this.fillColor; }
+      set { this.fillColor = value; }
+    }
+
+    private string toolTip;
+    public string ToolTip {
+      get { return toolTip; }
+      set { toolTip = value; }
+    }
+  }
+}
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/VisualSymbolicExpressionTreeNodeConnection.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/VisualSymbolicExpressionTreeNodeConnection.cs	(revision 9835)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/VisualSymbolicExpressionTreeNodeConnection.cs	(revision 9835)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+using System.Drawing.Drawing2D;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views {
+  public class VisualSymbolicExpressionTreeNodeConnection : object {
+    private static readonly Color defaultLineColor = Color.Black;
+    private static readonly DashStyle defaultDashStyle = DashStyle.Solid;
+
+    private Color lineColor;
+    public Color LineColor {
+      get { return lineColor; }
+      set { lineColor = value; }
+    }
+
+    private DashStyle dashStyle;
+    public DashStyle DashStyle {
+      get { return dashStyle; }
+      set { dashStyle = value; }
+    }
+
+    public VisualSymbolicExpressionTreeNodeConnection()
+      : base() {
+      lineColor = defaultLineColor;
+      dashStyle = defaultDashStyle;
+    }
+  }
+}
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Crossovers/TracingSymbolicExpressionTreeCrossover.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Crossovers/TracingSymbolicExpressionTreeCrossover.cs	(revision 9835)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Crossovers/TracingSymbolicExpressionTreeCrossover.cs	(revision 9835)
@@ -0,0 +1,113 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
+  /// <summary>
+  /// A base class for operators that perform a crossover of symbolic expression trees.
+  /// </summary>
+  [Item("SymbolicExpressionTreeCrossover", "A base class for operators that perform a crossover of symbolic expression trees.")]
+  [StorableClass]
+  public abstract class TracingSymbolicExpressionTreeCrossover : TracingSymbolicExpressionTreeOperator, ISymbolicExpressionTreeCrossover {
+    private const string ParentsParameterName = "Parents";
+    private const string ChildParameterName = "Child";
+
+    #region Parameter Properties
+    public ILookupParameter<ItemArray<ISymbolicExpressionTree>> ParentsParameter {
+      get { return (ScopeTreeLookupParameter<ISymbolicExpressionTree>)Parameters[ParentsParameterName]; }
+    }
+    public ILookupParameter<ISymbolicExpressionTree> ChildParameter {
+      get { return (ILookupParameter<ISymbolicExpressionTree>)Parameters[ChildParameterName]; }
+    }
+    #endregion
+
+    #region Properties
+    public ItemArray<ISymbolicExpressionTree> Parents {
+      get { return ParentsParameter.ActualValue; }
+    }
+    public ISymbolicExpressionTree Child {
+      get { return ChildParameter.ActualValue; }
+      set { ChildParameter.ActualValue = value; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected TracingSymbolicExpressionTreeCrossover(bool deserializing)
+      : base(deserializing) {
+    }
+    protected TracingSymbolicExpressionTreeCrossover(TracingSymbolicExpressionTreeCrossover original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    protected TracingSymbolicExpressionTreeCrossover()
+      : base() {
+      Parameters.Add(new ScopeTreeLookupParameter<ISymbolicExpressionTree>(ParentsParameterName, "The parent symbolic expression trees which should be crossed."));
+      Parameters.Add(new LookupParameter<ISymbolicExpressionTree>(ChildParameterName, "The child symbolic expression tree resulting from the crossover."));
+    }
+    public override IOperation Apply() {
+      if (Parents.Length != 2)
+        throw new ArgumentException("Number of parents must be exactly two for symbolic expression tree crossover operators.");
+
+      AddTracingVariablesToGlobalScope();
+
+      // save the nodes of parent0 in a list so we can track what modifications are made by crossover
+      var nodes0 = Parents[0].IterateNodesPrefix().ToList();
+      var nodes1 = Parents[1].IterateNodesPrefix().ToList();
+
+      // perform crossover
+      Child = Crossover(Random, Parents[0], Parents[1]);
+
+      // create another list of parent0's nodes, so we can compare it with the first list to see what changed
+      var childNodes = Child.IterateNodesPrefix().ToList();
+
+      // compare the two node lists and check the difference (comparing node references so we avoid false functional identity). 
+      int i = 0, min0 = Math.Min(nodes0.Count, childNodes.Count);
+      // find the index of the fragment (with respect to the prefix order of nodes) in Parent0
+      while (i < min0 && ReferenceEquals(nodes0[i], childNodes[i])) ++i;
+
+      var fragmentRoot = (i == min0) ? null : childNodes[i];
+      int j = 0;
+      // find the index of the fragment (with respect to the prefix order of nodes) in Parent1
+      while (j < nodes1.Count && !ReferenceEquals(nodes1[j], fragmentRoot)) ++j; // this works because the swapped subtree is not removed from the non-root parent
+
+      if (i < min0 && j < nodes1.Count && !ReferenceEquals(childNodes[i], nodes1[j])) {
+        throw new Exception("The two array elements should reference the same subtree.");
+      }
+
+      // map child to its corresponding parents from the previous generation
+      GlobalTraceMap[Child] = new ItemList<IItem>(from p in Parents select GlobalCloneMap[p]);
+      var fragment0 = new Fragment { Root = i == min0 ? null : nodes0[i], Index = i }; // fragment replaced in Parent0
+      var fragment1 = new Fragment { Root = fragmentRoot, Index = i, OldIndex = j }; // fragment received from Parent1
+      GlobalFragmentMap[Child] = fragment1; // map child to the index of its fragment
+      // transaction.FragmentIn = the fragment received from the other parent
+      // transaction.FragmentOut = the fragment that got replaced
+      GlobalGeneticExchangeMap.Add(new GeneticExchange { FragmentIn = fragment1, FragmentOut = fragment0 });
+      return base.Apply();
+    }
+
+    public abstract ISymbolicExpressionTree Crossover(IRandom random, ISymbolicExpressionTree parent0, ISymbolicExpressionTree parent1);
+  }
+}
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Fragment.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Fragment.cs	(revision 9835)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Fragment.cs	(revision 9835)
@@ -0,0 +1,66 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
+  [Item("Fragment", "Class that represents a tree fragment")]
+  [StorableClass]
+  public class Fragment : Item, IFragment {
+    [Storable]
+    private ISymbolicExpressionTreeNode root;
+    public ISymbolicExpressionTreeNode Root { get { return root; } set { root = value; } }
+    [Storable]
+    private int index = -1;
+    public int Index { get { return index; } set { index = value; } }
+    [Storable]
+    private int oldIndex = -1;
+    public int OldIndex { get { return oldIndex; } set { oldIndex = value; } }
+
+    private int length = -1;
+    public int Length {
+      get {
+        if (Root == null) return 0;
+        if (length == -1) length = Root.GetLength();
+        return length;
+      }
+      set { length = value; }
+    }
+
+    [StorableConstructor]
+    private Fragment(bool serializing) : base(serializing) { }
+    private Fragment(Fragment original, Cloner cloner)
+      : base(original, cloner) {
+      // avoid deep copy of the symbolic expression tree node
+      Root = original.Root;
+      Length = original.Length;
+      Index = original.Index;
+    }
+
+    public Fragment() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Fragment(this, cloner);
+    }
+  }
+}
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/GenericWrapper.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/GenericWrapper.cs	(revision 9835)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/GenericWrapper.cs	(revision 9835)
@@ -0,0 +1,28 @@
+﻿using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.EvolutionaryTracking {
+  [Item("Generic wrapper", "Wrapper class for non-item HeuristicLab objects")]
+  [StorableClass]
+  public class GenericWrapper<T> : Item where T : class, IDeepCloneable {
+    [Storable]
+    public T Content { get; private set; }
+
+    public GenericWrapper(T content) {
+      Content = content;
+    }
+
+    [StorableConstructor]
+    private GenericWrapper(bool serializing) : base(serializing) { }
+
+    private GenericWrapper(GenericWrapper<T> original, Cloner cloner)
+      : base(original, cloner) {
+      this.Content = cloner.Clone(Content);
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new GenericWrapper<T>(this, cloner);
+    }
+  }
+}
Index: branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/GeneticExchange.cs
===================================================================
--- branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/GeneticExchange.cs	(revision 9835)
+++ branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/GeneticExchange.cs	(revision 9835)
@@ -0,0 +1,40 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
+  [Item("GeneticExchange", "Class that represents a genetic transaction (the exchange of genetic material between two individuals)")]
+  [StorableClass]
+  public class GeneticExchange : Item {
+    public IFragment FragmentIn { get; set; }
+    public IFragment FragmentOut { get; set; }
+
+    [StorableConstructor]
+    private GeneticExchange(bool serializing) : base(serializing) { }
+    private GeneticExchange(GeneticExchange original, Cloner cloner) : base(original, cloner) { }
+    public GeneticExchange() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) { return new GeneticExchange(this, cloner); }
+  }
+}
